Qt 5.7 | Qt 3D | C++ Classes | QNode

Qt 5.7.1 Reference Documentation

# QNode Class

(Qt3DCore::QNode)

QNode is the base class of all Qt3D node classes used to build a Qt3D scene. More...

Header: | #include <QNode>
qmake: | QT += 3dcore
Since: | Qt 5.5

Inherited By:

Qt3DCore::QComponent, Qt3DCore::QEntity, Qt3DInput::QAbstractActionInput, Qt3DInput::QAbstractAxisInput, Qt3DInput::QAbstractPhysicalDevice, Qt3DInput::QAction, Qt3DInput::QAxis, Qt3DInput::QAxisSetting, Qt3DRender::QAbstractTexture, Qt3DRender::QAbstractTextureImage, Qt3DRender::QAttribute, Qt3DRender::QBuffer, Qt3DRender::QEffect, Qt3DRender::QFilterKey, Qt3DRender::QFrameGraphNode, Qt3DRender::QGeometry, Qt3DRender::QParameter, Qt3DRender::QPickingSettings, Qt3DRender::QRenderPass, Qt3DRender::QRenderTargetOutput, Qt3DRender::QShaderProgram, and Qt3DRender::QTechnique

- List of all members, including inherited members

## Properties

- enabled : bool
- parent : Qt3DCore::QNode *

## Public Functions

| QNode(QNode *parent = nullptr)
bool | blockNotifications(bool block)
QNodeVector | childNodes() const
QNodeId | id() const
bool | isEnabled() const
bool | notificationsBlocked() const
QNode * | parentNode() const

## Public Slots

void | setEnabled(bool isEnabled)
void | setParent(QNode *parent)

## Signals

void | enabledChanged(bool enabled)
void | nodeDestroyed()
void | parentChanged(QObject *parent)

## Protected Functions

void | notifyObservers(const QSceneChangePtr &change)
virtual void | sceneChangeEvent(const QSceneChangePtr &change)

## Related Non-Members

typedef | QNodePtr
typedef | QNodeVector
QNodeId | qIdForNode(QNode *node)
QNodeIdVector | qIdsForNodes(const T &nodes)

## Detailed Description

QNode is the base class of all Qt3D node classes used to build a Qt3D scene.

The owernship of QNode is determined by the QObject parent/child relationship between nodes. By itself, a QNode has no visual appearance and no particular meaning, it is there as a way of building a node based tree structure.

The parent of a QNode instance can only be another QNode instance.

Each QNode instance has a unique id that allows it to be recognizable from other instances.

When properties are defined on a QNode subclass, their NOTIFY signal will automatically generate notifications that the Qt3D backend aspects will receive.

See also QEntity and QComponent.

## Property Documentation

### enabled : bool

Holds the QNode enabled flag. By default a QNode is always enabled.

Note: the interpretation of what enabled means is aspect-dependent. Even if enabled is set to `false`, some aspects may still consider the node in some manner. This is documented on a class by class basis.

Access functions:

bool | isEnabled() const
void | setEnabled(bool isEnabled)

Notifier signal:

void | enabledChanged(bool enabled)

### parent : Qt3DCore::QNode *

Holds the immediate QNode parent, or null if the node has no parent.

Setting the parent will notify the backend aspects about current QNode instance's parent change.

Note: if parent happens to be null, this will actually notify that the current QNode instance was removed from the scene.

Access functions:

QNode * | parentNode() const
void | setParent(QNode *parent)

Notifier signal:

void | parentChanged(QObject *parent)

## Member Function Documentation

### QNode::QNode(QNode *parent = nullptr)

Creates a new QNode instance with parent parent.

Note: The backend aspects will be notified that a QNode instance is part of the scene only if it has a parent; unless this is the root node of the Qt3D scene.

See also setParent().

### bool QNode::blockNotifications(bool block)

If block is `true`, property change notifications sent by this object to aspects are blocked. If block is `false`, no such blocking will occur.

The return value is the previous value of notificationsBlocked().

Note that the other notification types will be sent even if the notifications for this object have been blocked.

See also notificationsBlocked().

### QNodeVector QNode::childNodes() const

Returns a list filled with the QNode children of the current QNode instance.

### QNodeId QNode::id() const

Returns the id that uniquely identifies the QNode instance.

### `[signal]` void QNode::nodeDestroyed()

emitted when the node is destroyed.

### bool QNode::notificationsBlocked() const

Returns `true` if aspect notifications are blocked; otherwise returns `false`. By default, notifications are not blocked.

See also blockNotifications().

### `[protected]` void QNode::notifyObservers(const QSceneChangePtr &change)

Sends the change QSceneChangePtr to any QBackendNodes in the registered aspects that correspond to this QNode.

For the common case of a QObject property change, QNode handles this for you automatically by sending a QPropertyUpdatedChange event to the backend nodes. You only need to call this function if you wish to send a specific type of change in place of the automatic handling.

### `[virtual protected]` void QNode::sceneChangeEvent(const QSceneChangePtr &change)

Called when one or more backend aspects sends a notification change to the current Qt3DCore::QNode instance.

Note: This method should be reimplemented in your subclasses to properly handle the change.

## Related Non-Members

### typedef Qt3DCore::QNodePtr

A shared pointer for QNode.

### typedef Qt3DCore::QNodeVector

List of QNode pointers.

### QNodeId Qt3DCore::qIdForNode(QNode *node)

Returns node id for node.

### QNodeIdVector Qt3DCore::qIdsForNodes(const T &nodes)

Returns vector of node ids for nodes.